'-- Thermo_t45.bas ---------------------------------------------- >>fst'11<< -
' - Demo fr den 4-Teile-AVR-Programmer www.FrankSteinberg.de/4TAP.htm
' - Interne Temperaturmessung auslesen und anzeigen
' - Compiler: BascomAVR   - C: ATtiny45
'-- V 20110422 ---------------------------------- http://www.FrankSteinberg.de -$regfile = "attiny45.dat"

'Konfiguration fr ATtiny45 laden:
$regfile "attiny45.dat"
'Taktfrequenz (1 MHz = Auslieferungszustand):
$crystal = 1000000

'Variablen deklarieren:
Dim W As Word                'Einzelwert des AD-Wandlers
Dim S As Long                'Summenwert fr Mittelwertbildung
Dim I As Word                'Index fr Zhlschleife
Dim T As String * 10         'formatierter Wert fr Ausgabe

'Der AD-Wandler fr Temperaturmessung einstellen:
Config Adc = Single , Prescaler = Auto , Reference = Internal_1.1
'AD-Wandler starten:
Start Adc

'Seriellen Ausgang auf Pin6=PB1, passend fr 4TAP:
'  2400 Baud, 8 Datenbits, keine Paritt, 1 Stoppbit,
'  invertierte Ausgabe fr direkten Anschluss an den PC
Open "comb.1:2400,8,n,1,inverted" For Output As #1

'Hinweistext ausgeben:
Print #1 , "ATtiny45 Thermometer"

'Hauptschleife:
'Ein Wandlerschritt (=1mV) entsprechen 0,9124 C
'9124 Wandlungen in Summe wren also durch 10000 zu teilen,
'um in Grad umzurechnen, bzw. 4562 Wandlungen / 5000
'um Zehntelgrad zu erhalten, teilen wir durch 500
Do
  S = 0                      'Summenwert zurcksetzen
  For I = 1 To 4562          '4562 Wandlungen um ca. alle 1 Sek einen Wert zu erhalten
    W = Getadc(15)           'Wert von Kanal 15 des AD-Wandlers holen
    S = S + W                'Werte aufsummieren
  Next I
  S = S / 500                'in zehntel Gradschritte zurckrechnen

  'Offsetwert des AD-Wandlers abziehen:
  '***  hier muss die Temperatur kalibriert werden          ***
  '***  nderung um 1 ndert den Temeraturwert um 0.1 Grad  ***
  S = S - 2596               '<- hier anpassen

  T = Str(s)                 'Zahl in String wandeln
  T = Format(t , "00.0")     'Wert mit einer Nachkommastelle formatieren
  Print #1 , T ; " Grad Celsius"       'Ergebnis als Text ausgeben
Loop

End